/*
 * Copyright 2021 Peter <peter@quantr.hk>.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package hk.quantr.netbeans.verilog.projecttype.settingpanel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Collection;
import org.apache.commons.io.FileUtils;
import org.netbeans.api.project.Project;
import org.netbeans.api.project.ui.OpenProjects;
import org.netbeans.spi.project.ui.support.ProjectCustomizer.Category;

/**
 *
 * @author Peter <peter@quantr.hk>
 */
public class TopLevelComponentPanel extends javax.swing.JPanel {

	private final Category category;
	private final Project project;

	/**
	 * Creates new form TopLevelComponentPanel
	 */
	public TopLevelComponentPanel(Category category, Project project) {
		this.category = category;
		this.project = project;

		initComponents();

		initTopModuleCombo();

		this.category.setStoreListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				System.out.println("");
			}
		});

	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        topModuleComboBox = new javax.swing.JComboBox<>();

        setLayout(new java.awt.GridBagLayout());

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(TopLevelComponentPanel.class, "TopLevelComponentPanel.jLabel1.text")); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weighty = 1.0;
        add(jLabel1, gridBagConstraints);

        topModuleComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        add(topModuleComboBox, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JComboBox<String> topModuleComboBox;
    // End of variables declaration//GEN-END:variables

	private void initTopModuleCombo() {
		File folder = new File(OpenProjects.getDefault().getOpenProjects()[0].getProjectDirectory().getPath());
		Collection<File> files = FileUtils.listFiles(folder, new String[]{"v"}, false);
		topModuleComboBox.removeAllItems();
		for (File f : files) {
			topModuleComboBox.addItem(f.getAbsolutePath());
		}
	}
}
